/* eslint no-unused-vars:0 */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Audio = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Image = require('./Image');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Common = {
  "inner-block": "Common__inner-block___1XxSf",
  "text-color": "Common__text-color___3ru4o",
  "description-color": "Common__description-color___3Ztpi",
  "text-link": "Common__text-link___1sysn"
};

var _Common2 = _interopRequireDefault(_Common);

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var _Audio = {
  "audio-container": "Audio__audio-container___2U9cg",
  "mobile": "Audio__mobile___3_0dH",
  "audio-coverphoto": "Audio__audio-coverphoto___pjw8Y",
  "enter": "Audio__enter___XNQfe",
  "enterActive": "Audio__enterActive___VPEQF",
  "leave": "Audio__leave___3jx_i",
  "leaveActive": "Audio__leaveActive___3mfxK",
  "appear": "Audio__appear___tNT6N",
  "appearActive": "Audio__appearActive___1n0L9",
  "audio-img-filter": "Audio__audio-img-filter___2zMvE",
  "audio-duration-block": "Audio__audio-duration-block___3RvYl",
  "audio-slider": "Audio__audio-slider___1yTq6",
  "audio-time-display": "Audio__audio-time-display___e8g2T",
  "audio-info-container": "Audio__audio-info-container___MI06J"
};

var _Audio2 = _interopRequireDefault(_Audio);

var _CircleProgressButton = require('./CircleProgressButton');

var _CircleProgressButton2 = _interopRequireDefault(_CircleProgressButton);

var _reactAddonsCssTransitionGroup = require('react-addons-css-transition-group');

var _reactAddonsCssTransitionGroup2 = _interopRequireDefault(_reactAddonsCssTransitionGroup);

var _reactHowler = require('react-howler');

var _reactHowler2 = _interopRequireDefault(_reactHowler);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcSlider = require('rc-slider');

var _rcSlider2 = _interopRequireDefault(_rcSlider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // requestAnimationFrame polyfill
// eslint-disable-line


if (process.env.BROWSER) {}

function getMinSecStr(time) {
  time = Math.round(time);
  var minutes = Math.floor(time / 60);
  var seconds = time - minutes * 60;
  seconds = seconds < 10 ? 0 + seconds.toString() : seconds.toString();
  return minutes + ':' + seconds;
}

var AudioSlider = function AudioSlider(_ref) {
  var duration = _ref.duration;
  var onSeekChange = _ref.onSeekChange;
  var seek = _ref.seek;

  return _react2.default.createElement(
    'div',
    { key: 'audio-slider', className: _Audio2.default['audio-slider'] },
    _react2.default.createElement(
      'div',
      { className: _Audio2.default['audio-time-display'] },
      getMinSecStr(seek)
    ),
    _react2.default.createElement(_rcSlider2.default, {
      tipFormatter: null,
      onChange: onSeekChange,
      value: seek,
      max: duration
    }),
    _react2.default.createElement(
      'div',
      { className: _Audio2.default['audio-time-display'] },
      getMinSecStr(duration)
    )
  );
};

var AudioController = function AudioController(props) {
  var duration = props.duration;
  var isOncePlayed = props.isOncePlayed;
  var isPlaying = props.isPlaying;
  var isFocused = props.isFocused;
  var onSeekChange = props.onSeekChange;
  var onToggle = props.onToggle;
  var seek = props.seek;


  return _react2.default.createElement(
    _reactAddonsCssTransitionGroup2.default,
    {
      transitionName: _Audio2.default,
      transitionAppear: true,
      transitionAppearTimeout: 1000,
      transitionEnterTimeout: 1000,
      transitionLeaveTimeout: 1000
    },
    !isOncePlayed ? _react2.default.createElement(
      'div',
      { key: 'notPlayedYet' },
      _react2.default.createElement(_CircleProgressButton2.default, {
        duration: duration,
        isOncePlayed: isOncePlayed,
        isPlaying: isPlaying,
        onToggle: onToggle,
        seek: seek
      }),
      _react2.default.createElement(
        'div',
        { className: _Audio2.default['audio-duration-block'] },
        getMinSecStr(duration)
      )
    ) : null,
    isOncePlayed && !isPlaying || isPlaying && isFocused ? _react2.default.createElement(
      'div',
      { key: 'oncePlayed' },
      _react2.default.createElement(_CircleProgressButton2.default, {
        duration: duration,
        isOncePlayed: isOncePlayed,
        isPlaying: isPlaying,
        onToggle: onToggle,
        seek: seek
      }),
      _react2.default.createElement(AudioSlider, {
        duration: duration,
        onSeekChange: onSeekChange,
        seek: seek
      })
    ) : null
  );
};

var Audio = function (_React$Component) {
  _inherits(Audio, _React$Component);

  function Audio(props) {
    _classCallCheck(this, Audio);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Audio).call(this, props));

    _this.state = {
      duration: 100,
      loaded: false,
      isOncePlayed: false,
      isPlaying: false,
      isFocused: false,
      seek: 0
    };
    _this.handleMouseClick = _this._handleMouseClick.bind(_this);
    _this.handleOnLoad = _this._handleOnLoad.bind(_this);
    _this.handleOnEnd = _this._handleOnEnd.bind(_this);
    _this.handleOnMouseOut = _this._handleOnMouseOut.bind(_this);
    _this.handleOnMouseOver = _this._handleOnMouseOver.bind(_this);
    _this.handleOnPlay = _this._handleOnPlay.bind(_this);
    _this.handleToggle = _this._handleToggle.bind(_this);
    _this.renderSeekPos = _this._renderSeekPos.bind(_this);
    _this.handleSeekChange = _this._handleSeekChange.bind(_this);
    return _this;
  }

  _createClass(Audio, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.clearRAF();
    }
  }, {
    key: '_handleMouseClick',
    value: function _handleMouseClick(e) {
      e.stopPropagation();
      this.setState({
        isFocused: !this.state.isFocused
      });
    }
  }, {
    key: '_handleToggle',
    value: function _handleToggle(e) {
      e.stopPropagation();

      this.setState({
        isOncePlayed: true,
        isPlaying: !this.state.isPlaying,
        isFocused: false
      });
    }
  }, {
    key: '_handleOnLoad',
    value: function _handleOnLoad() {
      this.setState({
        loaded: true,
        duration: this.player.duration()
      });
    }
  }, {
    key: '_handleOnPlay',
    value: function _handleOnPlay() {
      this.setState({
        isPlaying: true
      });
      this.renderSeekPos();
    }
  }, {
    key: '_handleOnEnd',
    value: function _handleOnEnd() {
      this.setState({
        isPlaying: false
      });
      this.clearRAF();
    }
  }, {
    key: '_handleOnMouseOver',
    value: function _handleOnMouseOver(e) {
      e.stopPropagation();
      this.setState({
        isFocused: true
      });
    }
  }, {
    key: '_handleOnMouseOut',
    value: function _handleOnMouseOut(e) {
      e.stopPropagation();
      this.setState({
        isFocused: false
      });
    }
  }, {
    key: '_handleSelect',
    value: function _handleSelect(e) {
      e.stopPropagation();
      this.props.onSelect(e);
    }
  }, {
    key: '_renderSeekPos',
    value: function _renderSeekPos() {
      this.setState({
        seek: this.player.seek()
      });
      if (this.state.isPlaying) {
        this._raf = (0, _raf2.default)(this.renderSeekPos);
      }
    }
  }, {
    key: '_handleSeekChange',
    value: function _handleSeekChange(seek) {
      var _this2 = this;

      this.setState({
        seek: seek
      }, function () {
        _this2.player.seek(seek);
      });
    }
  }, {
    key: 'clearRAF',
    value: function clearRAF() {
      _raf2.default.cancel(this._raf);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props;
      var content = _props.content;
      var device = _props.device;
      var _state = this.state;
      var duration = _state.duration;
      var isFocused = _state.isFocused;
      var isOncePlayed = _state.isOncePlayed;
      var isPlaying = _state.isPlaying;
      var seek = _state.seek;

      var _$get = _lodash2.default.get(content, 0, {});

      var url = _$get.url;
      var coverPhoto = _$get.coverPhoto;
      var title = _$get.title;
      var description = _$get.description;


      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)(_Audio2.default['audio-container'], _defineProperty({}, _Audio2.default['mobile'], device === 'mobile' ? true : false)) },
        _react2.default.createElement(
          'div',
          { className: _Audio2.default['audio-coverphoto'], onClick: this.handleMouseClick, onMouseEnter: this.handleOnMouseOver, onMouseLeave: this.handleOnMouseOut },
          _react2.default.createElement(
            'div',
            { className: _Audio2.default['audio-img-filter'], style: isOncePlayed ? {
                opacity: 1
              } : {} },
            _react2.default.createElement(_Image.Image, {
              content: [coverPhoto],
              isToShowDescription: false
            })
          ),
          _react2.default.createElement(AudioController, {
            duration: duration,
            isFocused: isFocused,
            isOncePlayed: isOncePlayed,
            isPlaying: isPlaying,
            onToggle: this.handleToggle,
            onSeekChange: this.handleSeekChange,
            seek: seek
          })
        ),
        _react2.default.createElement(
          'div',
          { className: _Audio2.default['audio-info-container'] },
          _react2.default.createElement(
            'h4',
            { className: (0, _classnames2.default)('text-center', _Common2.default['text-color']) },
            title
          ),
          _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: description } })
        ),
        _react2.default.createElement(_reactHowler2.default, {
          src: url,
          playing: isPlaying,
          onLoad: this.handleOnLoad,
          onPlay: this.handleOnPlay,
          onEnd: this.handleOnEnd,
          ref: function ref(_ref2) {
            return _this3.player = _ref2;
          }
        })
      );
    }
  }]);

  return Audio;
}(_react2.default.Component);

Audio.propTypes = {
  content: _react2.default.PropTypes.array.isRequired,
  customStyles: _react2.default.PropTypes.array,
  device: _react2.default.PropTypes.string
};

Audio.defaultProps = {
  content: [],
  customStyles: [],
  device: ''
};

exports.Audio = Audio;