'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _actionTypes = require('./action-types');

Object.keys(_actionTypes).forEach(function (key) {
  if (key === "default") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _actionTypes[key];
    }
  });
});
var groupEnum = exports.groupEnum = {
  CATEGORY: 'category',
  TAG: 'tag'
};
var pathEnum = exports.pathEnum = {
  CATEGORY: 'postcategories',
  TAG: 'tags'
};

var authorTypes = exports.authorTypes = {
  writter: '採訪',
  photographer: '攝影',
  designer: '設計',
  engineer: '工程'
};

var ARTICLE = exports.ARTICLE = 'ARTICLE';

var HOME = exports.HOME = 'HOME';

var CATEGORY = exports.CATEGORY = 'CATEGORY';

var basePath = exports.basePath = 'https://www.twreporter.org';

var appId = exports.appId = 962589903815787;

var donatePath = exports.donatePath = 'https://twreporter.backme.tw/cashflow/checkout?project_id=175&reward_id=718';

var categoryPath = exports.categoryPath = {
  taiwanPath: '/category/taiwan',
  reviewPath: '/category/review',
  photographyPath: '/photography',
  intlPath: '/category/intl',
  culturePath: '/category/culture'
};

var navPath = exports.navPath = [{ title: '台灣', path: '/category/taiwan' }, { title: '國際兩岸', path: '/category/intl' }, { title: '文化', path: '/category/culture' }, { title: '影像', path: '/photography' }, { title: '專欄', path: '/category/review' }];

var subnavPath = exports.subnavPath = [{ title: '轉型正義', path: '/a/transitional-justice-content' }, { title: '0206地震', path: '/a/0206earthquake-content' }, { title: '亞洲森林浩劫', path: '/a/asia-forest-content' }, { title: '五輕關廠', path: '/a/refinery-content' }, { title: '急診人生', path: '/a/emergency-content' }];

var colors = exports.colors = {
  whiteBg: '#F7F8F8',
  darkBg: '#3e3a39'
};